%ext ck4
%version 1.4

###########################
# The Usual Junk Required #
###########################

# Load the edited loading screen
%patchfile $1fe47 ck4load.bin

# Load the modified graphics please
%egahead EGAHEAD.CK4

# Load the maps now
%maphead maphead.ck4

# Load the tile properties thanks
%patchfile $249C2 keen4.tli

#Disable star wars story screen
%patch $3CBD $04D1W

#Keenwave patch file; Patch sounds Keen 4:
%patchfile $20DF0 AUDIOHED.CK4	#Audio header
%patchfile $354F6 AUDIODCT.CK4	#Audio dictionary
#Change number of songs:
%patch $8CEF $9B $00
%patch $8C75 $C893W
%patch $8C83 $C893W
%patch $8D83 $C893W

############################
# Miscellaneous            #
############################
# Level Related #
#################

#Eliminate air-door entry glitch
%patch $2FD5E $0C02W

#Swimming Keen clipping is normal 
%patch $F622 $0001W

#Bridge thickness - Keen 4
%patch $C1F2 $0004W

## Foot ##

#What picks the Foot destination to use (lv 14 done)
%patch $DE36 $7A3AW  $0000W $75

#Foot location 1:
%patch $DE43 $33 #Horizontal location on map in tiles (end location needs to be to the left of start location)
%patch $DE58 $50 #Vertical location on map in tiles

#Location 2: (When exiting POTF)
%patch $DE78 $30 #Horizontal location on map in tiles
%patch $DE8C $17 #Vertical location on map in tiles


#BwB levels: all levels above 17
%patch $60FD $12 $77

#WoW exits and scrolls normally
%patch $905B $90 $90

################
# Game Related #
################

### Status Window ###

#"Rescued"
%patch $2F49C "RELICS" $00

#Background rectangle
%patch $7E4A $005FW #Horizontal position
%patch $7E42 $0020W #Width

%patch $7E6A $0060W #Horizontal position

#"Drops"
%patch $2F4CB "OSTRUM" $00

#What wins game (3 members)
%patch $6AE4  $7A5EW  $03 $74

######################
# Default highscores #
######################
#Defaults read from
%patch $5A09  $43C4W
%patch $5B58  $43C4W
%patch $5B63  $43C4W
%patch $5B89  $43C4W
%patch $5C06  $43C4W
%patch $194FF $43C4W
%patch $196A9 $43C4W

#Names:
%patch $33234 "Bubbatom         " $00
%patch $33274 "                 " $00
%patch $332B4 "55Aavenue        " $00
%patch $332F4 "Kohntarkosz      " $00
%patch $33334 "Levellass        " $00
%patch $33374 "                 " $00
%patch $333B4 "                 " $00
%patch $333F4 "Id Software - '91" $00


#########
# Other #
#########

#Terminator text palette:
%patch $2F078 $00 $0E $0E $1E $01 $01 $01 $01     #Dark colors
              $11 $11 $11 $11 $13 $13 $13 $13 $00 #Light colors (and border color)


#Terminator text palette 2, screen moves out:
%patch $2F089 $00 $0E $0E $1E $01 $01 $01 $01     #Dark colors
              $11 $11 $11 $11 $13 $13 $13 $0E $00 #Light colors (and border color)

#########
# Music #
#########

#Where music list is read from:
%patch $8CCD $0396W  #$2F206
%patch $8CA4 $14     #Total number of level entries

#Song values:
#0: Ocflore5          1: Ocflore6
#2: Ocflore7          3: 55Awater
#4: Krobot            5: Ksphere
#6: marsbase          7: nukeduke
#8: Ocflore2          9: Ocflore3
#A: Ocflore4          B: Swords

#This is the music played in each level:
#             VALUE   LEVEL                 MUSIC PLAYED         LEVEL No
%patch $2F206 $0008W  #Map                  (Ocflore2)             0
              $0006W  #Airport	            (marsbase)             1
              $0003W  #Imber Inlet          (55Awater)             2
              $0005W  #Enkri Borough        (Ksphere)              3
              $0007W  #Jungle Crags         (nukeduke)             4
              $0009W  #Frigid Quarry        (Ocflore3)             5
              $0009W  #Enkri Sanctuary      (Ocflore3)             6
              $0001W  #Pelagic Pillars      (Ocflore6)             7
              $0006W  #Ostrum Absorber      (marsbase)             8
              $0009W  #Mt Amnis             (Ocflore3)             9
              $000BW  #Dorsal Obelisk       (swords)              10
              $0002W  #Ancient Observatory  (Ocflore7)            11
              $0000W  #Enkri Shanty         (Ocflore5)            12
              $000AW  #Savannak Temple      (Ocflore4)            13
              $0007W  #Dorsal Battleship    (nukeduke)            14
              $0005W  #Swallowed Spire      (Ksphere)             15
              $000BW  #Evergreen Gate       (swords)              16
              $0003W  #Sunken Sanctum       (55Awater)	          17
              $0000W  #Thicket Steeple      (Ocflore5)            18
              $0004W  #High scores          (robot)               19

#Other music played: (Values here level number in which same music is used.)
%patch $5836 $0000W #Story demo (Not used!)
%patch $9CD7 $000DW #Ending Sequence (Savannak Temple)
%patch $F107 $FFFFW #Talking to Lindsey (none)
%patch $F4CA $0013W #Talking to Ancient (robot)

#Add new music
#Index of first music chunk within audio chunks:
%patch $8CEF $0096W

#Start address of music chunks
#reduce start address by 2x that of "First Audio Entry"
%patch $8C75 $C889W #Clear_music()
%patch $8C83 $C889W #Clear_music()
%patch $8D83 $C889W #StartMusic()
%patch $8C91 $0C    #Total Number of Songs

############################
# Level Names and Entries  #
############################

#Level 0 name
%level.name 0 Ocflore V
#Level 0 entry text
%level.entry 0 Keen navigates 
planet Ocflore

#Level 1 name
%level.name 1 Ocflore Airport
#Level 1 entry text
%level.entry 1 Keen splashes down at
the Ocflore Airport

#Level 2 name
%level.name 2 Imber Inlet
#Level 2 entry text
%level.entry 2 Keen paddles to the
Imber Inlet

#Level 3 name
%level.name 3 The Enkri Borough
#Level 3 entry text
%level.entry 3 Keen cuts through
the Enkri Borough

#Level 4 name
%level.name 4 Jungle Crags
#Level 4 entry text
%level.entry 4 Keen plunges down
the Jungle Crags

#Level 5 name
%level.name 5 Frigid Quarry
#Level 5 entry text
%level.entry 5 Keen cascades into
the Frigid Quarry

#Level 6 name
%level.name 6 Enkri Sanctuary
#Level 6 entry text
%level.entry 6 Keen beholds the
Enkri Sanctuary

#Level 7 name
%level.name 7 Pelagic Pillars
#Level 7 entry text
%level.entry 7 Keen dangles on
Pelagic Pillars

#Level 8 name
%level.name 8 Ostrum Absorbor
#Level 8 entry text
%level.entry 8 Keen burrows his way to
the Ostrum Absorbor

#Level 9 name
%level.name 9 Mount Amnis
#Level 9 entry text
%level.entry 9 Keen conquers
Mount Amnis

#Level 10 name
%level.name 10 Dorsal Obelisk
#Level 10 entry text
%level.entry 10 Keen filters through 
the Dorsal Obelisk

#Level 11 name
%level.name 11 Ancient Observatory
#Level 11 entry text
%level.entry 11 Keen reveals 
the Ancient Observatory

#Level 12 name
%level.name 12 The Enkri Shanty
#Level 12 entry text
%level.entry 12 Keen cracks into 
the Enkri Shanty

#Level 13 name
%level.name 13 Savanak Temple
#Level 13 entry text
%level.entry 13 Keen delves into 
the Savanak Temple

#Level 14 name
%level.name 14 The Dorsal Battleship
#Level 14 entry text
%level.entry 14 Keen teleports aboard
the Dorsal Battleship

#Level 15 name
%level.name 15 Swallowed Spire
#Level 15 entry text
%level.entry 15 Keen subsides into 
the Swallowed Spire

#Level 16 name
%level.name 16 Evergreen Gate
#Level 16 entry text
%level.entry 16 Keen passes through
the Evergreen Gate

#Level 17 name
%level.name 17 Sunken Sanctum
#Level 17 entry text
%level.entry 17 Keen plunges into 
the Sunken Sanctum

#Level 18 name
%level.name 18 The Thicket Steeple
#Level 18 entry text
%level.entry 18 Keen catapults up 
the Thicket Steeple

################
#              #
# Text Patches #
#              #
################

#Level end text
%patch $2F16F "You didn't make it past"
%patch $2F187 "Try Again"
%patch $2F191 "  Exit to Ocflore  "

#Wetsuit Text
%patch $30A4B "  This is mine now! "
%patch $30A60 "  Let's swim!   "

#Keen 4 :
%patch $6B6C  $0008W #Width
%patch $6B70  $001AW #Width
%patch $6B81  $0389W #Text called from
%patch $2F1F9 "Just a sec" $00

################################
# Dorsal Relics (Member texts) #
################################

#Council Members text
%patch $30C17 "Keen comes across an"
%patch $30C2C "artifact the old"
%patch $30C3D " Dorsal spoke of. "
%patch $30C50 " An eleborate "
%patch $30C5F "   relic.   "

#Council Members text - Keen's replies
%patch $30A71 "Such an intricate bit"
%patch $30A87 " of gear! "

%patch $30A92 "I wonder how these "
%patch $30AA6 "things work."

%patch $30AB3 " What now?  "

####################
# Dorsal (Lindsey) #
####################

#Hint level 5
%patch $30A25 "   The Dorsal says:   "
%patch $30999 " Keep an eye out for a"
%patch $309B0 "  purple key hidden  "
%patch $309C6 "inside a coral wall."
%patch $309DB "      "
%patch $309FA "Alright, I'll "
%patch $30A09 "     keep my eyes"
%patch $30A1A " peeled! "

#Hint level 7
%patch $30A25 "   The Dorsal says:   "
%patch $3094C " It's dangerous to  "
%patch $30961 "stumble in teleporters "
%patch $30979 "  at the Swallowed   "
%patch $3098F " Spire. "
%patch $309E3 "   Don't you worry!   "

#########################
#                       #
# ENEMY RELATED PATCHES #
#                       #
#########################

##############
# Schoolfish #
##############

# fullclip schoolfish hitbox
%patch $A7B2 $0180w	# width  (default: $0100w = 16 pixels)
%patch $A7B7 $0100w	# height (default: $0080w =  8 pixles)

########
# Mine #
########

#Mine explodes
#patch $3271E $01B9W $01B9W
#patch $32728 $001EW        #Animation speed
#patch $3273C $01BAW $01BAW
#patch $32746 $00EEW        #Animation speed (Vanishes) (Made longer)

#########
# Cloud #
#########

%patch $10A36 $0014W #Speed when moving

#Zap Keen
%patch $31896 $01F4W $01F4W
%patch $318A0 $0001W        #Pause while lightening strikes

############
# Dopefish #
############

#Seek Keen vertically - reversed
%patch $12177 $FFFFW
%patch $1218B $0001W

################
# Mad Mushroom #
################

#Number of low\high bounces
%patch $FF90 $0002W #Xth jump is tall
%patch $FF97 $0000W #Reset value

%patch $FFBB $FFE8W #Small
%patch $FF9C $FFB6W #High
%patch $FF7C $0000W #Bounce down from ceiling

##################
# Treasure Eater #
##################

#Treasure Eater foreground values
%patch $11A4C $0001W #Treasure Eater

###########
# Bounder #
###########

#Bounder can still be stood on after being shot
%patch $11172 $EB $02

%patch $111BC $FFD8W #Bounder's vertical jump height
%patch $111FE $0010W #Bounder's jump length (With Keen riding)

#Bounders chase Keen
%patch $111C2 $90 $90

#Bounder collision: Lethal, shootable
%patch $11138 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09     #Check for Keen (Type 2)
              $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $0E $B8         #If Keen, kill him; check for shot (Type 3)
              $2F8AW  $50 $57 $56 $9A $09DC1695RL     $83 $C4 $06 $5F $5E $5D $CB #If shot, become $2F8AW


###############
# Poison Slug #
###############

#Crawling
%patch $30E8E $0080W $0000W #Speed 1
%patch $30EAC $0080W $0000W #Speed 2

#Foreground
%patch $FD9C  $0000W #Poison slug

#Slug collision produces only one type of slug
%patch $FE6A $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09 #Check for Keen (Type 2)
         $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $1F $B8     #If Keen, kill him; check for shot (Type 3)
         $206CW  $50 $57 $56 $9A $09DC1695RL     $83 $C4 $06 $C7 $44 $18     #If shot, become $206C
         $FFE8W  $8B $44 $0E $D1 $E0 $D1 $E0 $D1 $E0 $89 $44 $16 $5F $5E $5D #Jump into the air $FFE8
             $CB

##########
# Sprite #
##########

#Sprite's shots have 3 frames
%patch $126A6 $3836W
%patch $326FE $3836W

#Sprite uses new collision
%patch $32624 $2EE70146RL
%patch $32642 $2EE70146RL
%patch $32660 $2EE70146RL
%patch $3267E $2EE70146RL

#Stunned sprite action (1st frame of old bullet)
%patch $32688 $01B4W $01B4W $0002W $0000W $0000W $00F0W $0000W $0000W
              $09DC16C9RL   $00000000L    $09DC176ERL   $3818W

#New Sprite collision, react to Keen's shot, kill Keen
%patch $2EFB6 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09
              $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $18 $C7 $44
              $16 $0000W  $C7 $44 $06 $0001W  $B8 $3818W  $50 $57 $56 $9A $09DC1695RL
                          $83 $C4 $06 $5F $5E $5D $CB

###########
# SkyPest #
###########

#Skypest don't land but slide along ground
%patch $10797 $2E

#Skypest can be stunned:
#New collision for Skypest, stunnable =$037D055ERL
%patch $3D2E $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09 #Check for Keen (Type 2)
             $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $1F $B8     #If Keen, kill him; check for shot (Type 3)
             $24C2W  $50 $57 $56 $9A $09DC1695RL     $83 $C4 $06 $C7 $44 $18     #If shot, become $24C2W
             $FFE8W  $8B $44 $0E $D1 $E0 $D1 $E0 $D1 $E0 $89 $44 $16 $5F $5E $5D #Jump into the air $FFE8
             $CB

#Skypests use new collision
%patch $3130A $037D055ERL #Flying Skypest
%patch $31328 $037D055ERL #Flying Skypest

#Stunned Skypests act properly
%patch $31332 $01C8W $01C8W $0002W $0000W $0000W $0000W $0000W $0000W
              $09DC16C9RL   $00000000L    $09DC1913RL   $0000W

#############
# Inch Worm #
#############

#Inchworm Speed
%patch $31D16 $0100W $0000W #Speed 1
%patch $31D34 $0100W $0000W #Speed 2

#Keen appears in front of Inchworm
%patch $10ED0 $0000W #Inchworm

#Inchworm avoids keen (behavior code)
%patch $10F70 $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $8B $1E $D6 $A7 $3B $47
              $0A $76 $08 $C7 $44 $0E $0001W  $5E $5D $CB $C7 $44 $0E $FFFFW
              $5E $5D $CB


##############NEW LASS STUFF############

#Slave Inchworm and Arachnut caches
%patch $EAEA $010AW

#Inchworms use new collision codes
%patch $31D1E $037D0526RL
%patch $31D3C $108007B5RL

#Disable EGAGRAPH check in Keen 4 (Frees 389 bytes at $3CF6)
%patch $3CE5 $90 $90

#Inchworm collision: React to other worms by converting other worm =$037D0526RL
%patch $3CF6 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $10 $75 $09
             $56 $9A $037D0543RL     $83 $C4 $02 $5F $5E $5D $CB

#Skypest sect
%patch $1073 $55 $8B $EC $56 $57 $8B $7E $06 $8B $76 $08 $81 $7C $1C $110CW
             $74 $0E $81 $7C $1C $112AW  $74 $07 $81 $7C $1C $1148W  $75 $1D
             $B8 $24C2W  $50 $57 $9A $09DC120ARL     $83 $C4 $04 $B8 $0016W
             $50 $9A $187409F1RL     $83 $C4 $02 $C7 $05 $0001W  $5F $5E $5D
             $CB

#Convert colliding worm =$037D0543RL
%patch $3D13 $55 $8B $EC $56 $8B $76 $06 $C7 $04 $0022W  $B8 $011FW  $50 $56
             $9A $09DC120ARL     $83 $C4 $04 $5E $5D $CB

#Converted worm, returns to normal if left =$011FW
%patch $2EF8F $0000W $0000W $0000W $0000W $0000W $0008W $0000W $0000W
              $10800793RL   $00000000L    $09DC176ERL   $2E9AW

#Clipped InchCol: React to converted worms =$108007B5RL
%patch $10FB5 $55 $8B $EC $56 $57 $8B $76 $06 $8B $5E $08 $83 $3F $22 $74 $03
              $E9 $010DW  $B8 $002DW  $50 $9A $187409F1RL     $83 $C4         #Play sound $2D
              $02 $81 $6C $0C $0000W  $C7 $04 $000AW  $B8 $2378W  $50 $56 $9A #Turn worm into Arachnut
              $09DC120ARL     $83 $C4 $04 $B8 $0001W  $50 $9A $06BD1E11RL
              $83 $C4 $02 $8B $44 $0A $2D $0080W  $8B $1E $D8 $A7 $89 $47 $0A #Up smoke
              $8B $44 $0C $05 $0100W  $89 $47 $0C $C7 $47 $20 $0003W  $B8 $2E22W
                  $50 $53 $9A $09DC118CRL     $83 $C4 $04 $B8 $0001W  $50 $9A
              $06BD1E11RL     $83 $C4 $02 $8B $44 $0A $05 $0100W  $8B $1E $D8 #Left smoke
              $A7 $89 $47 $0A $8B $44 $0C $05 $0180W  $89 $47 $0C $C7 $47 $20
              $0003W  $B8 $2E22W  $50 $53 $9A $09DC118CRL     $83 $C4 $04 $B8
              $0001W  $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $44 $0A $05 $0280W
%patch $11064     $8B $1E $D8 $A7 $89 $47 $0A $8B $44 $0C $05 $0100W  $89 $47 #Right smoke
              $0C $C7 $47 $20 $0003W  $B8 $2E22W  $50 $53 $9A $09DC118CRL     
              $83 $C4 $04 $B8 $0001W  $50 $9A $06BD1E11RL     $83 $C4 $02 $8B
              $44 $0A $8B $1E $D8 $A7 $89 $47 $0A $8B $44 $0C $2D $0080W  $89 #Down smoke
              $47 $0C $C7 $47 $20 $0003W  $B8 $2E22W  $50 $53 $9A $09DC118CRL
                  $83 $C4 $04 $8B $1E $D6 $A7 $8B $7F $48 $EB $11 $83 $3D $22 #Remove converted worm
              $75 $09 $57 $9A $06BD1E8BRL     $83 $C4 $02 $8B $7D $48 $0B $FF
              $75 $EB $5F $5E $5D $CB

#Converted worm reverts back to normal worm if left without removal =$10800793RL
%patch $10F93 $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $C7 $04 $0010W  $5E $5D $CB

#Special squish collision for Inchworms = $0B8015CDRL
%patch $CDCD $55 $8B $EC $56 $57 $8B $7E $06 $8B $76 $08 $8B $04 $3D $0010W  #Worm,
             $74 $05 $3D $0022W  $75 $21 $B8 $0016W  $50 $9A $187409F1RL
             $83 $C4 $02 $C7 $04 $0001W  $B8 $24C2W  $50 $56 $9A $09DC120ARL
                 $83 $C4 $04 $5F $5E $5D $CB $E9 $FEAEW

#Keen bouncing uses squishing collision
#patch $2FF90 $0B8015CDRL
#patch $2FFAE $0B8015CDRL
#patch $2FFCC $0B8015CDRL

#Squished Inchworm animations
#patch $31332 $0208W $0208W

#No stun stars for squished worm
#patch $31342 $09DC1701RL $00000000L $09DC176ERL

########
# Lick #
########

#Lick Foreground variable
%patch $112E6 $0000W

#Lick is deadly all the time, new collision
%patch $11423 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09 #Check for Keen (Type 2)
              $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $12
              $B8 $312EW  $50 $57 $56 $9A $09DC1695RL     $83 $C4 $06 $83 $6C
              $18 $10 $5F $5E $5D $CB

#Lick blocks shots but is not stunnable
%patch $1140D $57 $9A $0D8F0D43RL     $83 $C4 $02 $5F $5E $5D $CB

#Bouncing Lick uses this too
%patch $31E4A $10800C23RL #Lick bouncing
%patch $31E68 $10800C23RL #Lick bouncing
%patch $31E86 $10800C23RL #Lick bouncing
%patch $31EA4 $10800C23RL #Lick bouncing

#Lick movement code less flame checks (value FFB0 is jump height)
%patch $11342 $55 $8B $EC $83 $EC $02 $56 $57 $8B $76 $06 $8B $44 $0A $8B $1E #Check Keen's location
              $D6 $A7 $3B $47 $0A $76 $07 $C7 $44 $0E $FFFFW  $EB $05 $C7 $44 #Change H direction to follow him
              $0E $0001W  $8B $44 $0E $B1 $05 $D3 $E0 $89 $44 $16 $C7 $44 $18
              $FFC8W  $5F $5E $8B $E5 $5D $CB                                 #Large jump 

###########
# Mimrock #
###########

#Mimrock foreground variable
%patch $11E85 $0000W

#Mimrock has the mad mushroom collision while Pouncing 
%patch $32390 $0FA804BERL 
%patch $323AE $0FA804BERL 
%patch $323CC $0FA804BERL 
%patch $323EA $0FA804BERL #bouncing on the ground

#Attack jump
%patch $11F65 $FFE0W #Jump height
%patch $11F5B $0014W #Jump length

#############
# Berkeloid #
#############

#Berkeloid shots fly horizontally
%patch $31B58 $00000000L
%patch $31B76 $00000000L
%patch $31B4C $0001W
%patch $31B6A $0001W
%patch $31B54 $0040W #Speed 1
%patch $31B72 $0040W #Speed 2

#Berkeloid flames smash on walls as well as floors
%patch $10D5E $55 $8B $EC $56 $8B $76 $06 $83 $7C $38 $00 $75 $0C $83 $7C $3C
              $00 $75 $06 $83 $7C $36 $00 $74 $19 $B8 $0028W
                  $50 $9A $187409F1RL     $83 $C4 $02 $B8 $2D14W  $50 $56 $9A
              $09DC120ARL     $83 $C4 $04 $FF $74 $20 $33 $C0 $50 $FF $74 $1E
              $FF $74 $0C $FF $74 $0A $8B $C6 $05 $46 $00 $50 $9A $16541641RL
              $83 $C4 $0C $5E $5D $CB

#############
# Blue Bird #
#############

#Walking birds (easy, medium, hard) are separate from flying birds
#Spawn points
%patch $EECB $1A84W #'I Keen' (Easy bird)
%patch $EECD $1A7DW #'Mom' (Normal bird)
%patch $EECF $1A76W #'Dad' (Hard bird)

#Initiation code at + $1A76
%patch $10366 $83 $3E $7A6CW  $03 $7C $19 $83 $3E $7A6CW  $02 $7C $12 $FF $76
              $FC $57 $9A $0FA808A1RL     $83 $C4 $04 $C7 $06 $5F $CB $0001W
              $E9 $EA74W

#Flying bird spawn code = $0FA808A1RL
%patch $10321 $55 $8B $EC $B8 $01 $00 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B
              $1E $D8 $A7 $C7 $07 $001BW  $C7 $47 $02 $0001W  $C7 $47 $20 $0002W
                  $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0
              $05 $FF1FW  $89 $47 $0C $B8 $224CW  $50 $53 $9A $09DC118CRL
              $83 $C4 $04 $5D $CB

#Stop the flying birds becoming walking birds:
%patch $103D0 $EB #Bird doesn't land when Keen is standing on ground level with it
%patch $1048B $EB #Don't land when Keen below it and Bird near ground

#Stop the walking birds flying or going to stunned bird
%patch $31026 $0173W $016FW $0000W $0000W $0001W $0078W $0080W $0000W #Waiting bird
              $00000000L    $0FA804BERL   $09DC1795RL   $21F2W
%patch $31044 $0173W $016FW $0000W $0000W $0001W $0007W $0080W $0000W #Walking birds
              $00000000L    $0FA804BERL   $09DC1795RL   $21F2W
%patch $31062 $0174W $0170W $0000W $0000W $0001W $0007W $0080W $0000W
              $00000000L    $0FA804BERL   $09DC1795RL   $2210W
%patch $31080 $0175W $0171W $0000W $0000W $0001W $0007W $0080W $0000W
              $00000000L    $0FA804BERL   $09DC1795RL   $222EW
%patch $3109E $0176W $0172W $0000W $0000W $0001W $0007W $0080W $0000W
              $10800770RL   $0FA804BERL   $09DC1795RL   $21D4W

#Eggs hatch to flying birds
%patch $10135 $224CW

#Stunned birds unstun to flying
%patch $311E6 $224CW

#Fix walking spawn height (Stop it floating in air)
%patch $1006A $FF1FW

#Bird stunned
%patch $31152 $017BW $017BW $0002W $0000W $0000W $0000W $0000W $0000W
              $09DC16C9RL   $00000000L    $09DC1913RL   $0000W

#Walking Speed
%patch $31050 $0060W $0060W
%patch $31066 $0060W $0060W
%patch $3108C $0060W $0060W
%patch $310AA $0060W $0060W

#Foreground for egg
%patch $FFFB  $0001W #Egg

#Flying Speed
%patch $1027D $0020W #Left\right ACCELERATION when flying
%patch $10299 $0010W #Up ACCELERATION when flying
%patch $102AD $0010W #Down ACCELERATION when flying

###########
#Stun star#
###########

#Skypest: type 4
%patch $B7EE $19A8W

#Type 4 position
%patch $B768 $C7 $46 $FE $0040W  $BF $FF80W $EB $1C 

#Lick: type 5
%patch $B7FC $19B2W

#Type 5 position
%patch $B772 $C7 $46 $FE $0040W  $BF $FEA2W  $EB $12 

#Compress normal K collision for space (Frees $CDCD-CE31)
%patch $CCA9 $55 $8B $EC $56 $57 $8B $7E $06 $8B $76 $08 $8B $04 $3D $0011W  #Foot
             $75 $06 $C7 $06 $7A70W  $0007W  $3D $0006W  $75 $38 $83 $7D $36 #Council
             $00 $74 $2E $83 $3E $A7EDW  $0E $75 $15 $9A $0E8F07D9RL     $9A
             $16540D59RL     $56 $9A $06BD1E8BRL     $83 $C4 $02 $EB $12 $B8
             $001FW  $50 $9A $187409F1RL     $83 $C4 $02 $C7 $06 $7A70W  $0003W
                 $5F $5E $5D $CB $3D $000FW  $75 $0F $33 $C0 $50 $56 $57 $9A #Bounders
             $09DC0DA0RL     $83 $C4 $06 $EB $E8 $3D $0021W  $75 $06 $83 $7C #Platforms, stunned
             $44 $0F $74 $05 $3D $0014W  $75 $13 $83 $3E $7A6EW  $00 $75 $D1
             $56 $57 $9A $09DC0D33RL     $83 $C4 $04 $EB $C5 $3D $0018W  $75 #Lindsey
             $15 $9A $0E8F0645RL     $56 $9A $06BD1E8BRL     $83 $C4 $02 $9A #Items
             $16540D59RL     $EB $AB $3D $0004W  $75 $A6
%patch $CD54                                                 $8B $5C
             $3E $D1 $E3 $FF $B7 $13DCW  $9A $187409F1RL     $83 $C4 $02 $C7
             $04 $0001W  $C7 $44 $20 $0003W  $8B $5C $3E $D1 $E3 $8B $87 $140CW
                 $89 $44 $1E $8B $5C $3E $D1 $E3 $FF $B7 $13F4W  $9A $06BD1EF2RL
                 $83 $C4 $02 $83 $7C $3E $04 $7D $0B $8B $5C $3E $D1 $E3
             $FF $87 $7A60W  $EB $20 $83 $7C $3E $0A $75 $06 $FF $06 $7A6AW
             $EB $14 $83 $7C $3E $0B $75 $0E $8B $1E $7A6CW  $D1 $E3 $8B $87
             $13D4W  $01 $06 $7A58W  $B8 $1F28W  $50 $56 $9A $09DC120ARL   
             $83 $C4 $04 $5F $5E $5D $CB

#############################################
# K1n9_Duk3's Customized Screen Update Code #
#############################################

#replace the v1.4 delay code with my custom VW_SetScreen code
#(my VW_SetScreen is bigger than the one in v1.4)
%patch $1E7F9
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$BA $03DAw		#	mov	dx, 3DAh
	$FA			#	cli
				#@l1:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$74 $FB			#	jz	@l1
				#@l2:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$75 $FB			#	jnz	@l2
	$8B $4E $06		#	mov	cx, [bp+arg_start]
	$BA $03D4w		#	mov	dx, 3D4h
	$B0 $0C			#	mov	al, 0Ch
	$EE			#	out	dx, al
	$42			#	inc	dx
	$8A $C5			#	mov	al, ch
	$EE			#	out	dx, al
	$4A			#	dec	dx
	$B0 $0D			#	mov	al, 0Dh
	$EE			#	out	dx, al
	$8A $C1			#	mov	al, cl
	$42			#	inc	dx
	$EE			#	out	dx, al
	$F7 $06 $7A14w $0001w	#	test	fixjerky, 1
	$74 $03			#	jz	@l3
	$E8 $0053w		#	call	WaitVBL
				#@l3:
	$F7 $06 $7ADEw $0001w	#	test	nopan, 1
	$75 $0C			#	jnz	l4
	$BA $03C0w		#	mov	dx, 3C0h
	$B0 $33			#	mov	al, 33h
	$EE			#	out	dx, al
	$EB $00			#	jmp	$
	$8A $46 $08		#	mov	al, [bp+arg_pan]
	$EE			#	out	dx, al
				#@l4:
	$F7 $06 $7A14w $0001w	#	test	fixjerky, 1
	$75 $03			#	jnz	@l5
	$E8 $0034w		#	call	WaitVBL
				#@l5:
	$FB			#	sti
	$5D			#	pop	bp
	$CB			#	retf

#replace the start of VW_SetScreen with a jump into my new code (see above):
%patch $1E87A
	$E9 $FF7Cw

#and overwrite the rest of the old VW_SetScreen code with my WaitVBL code:
	$8B $1E $A53Dw		#	mov	bx, word ptr TimeCount
	$BA $03DAw		#	mov	dx, 3DAh
				#@wait:	
	$FB			#	sti
	$EB $00			#	jmp	short $
	$FA			#	cli
	$EC			#	in	al, dx
	$A8 $08			#	test	al, 8
	$75 $0A			#	jnz	@done
	$A1 $A53Dw		#	mov	ax, word ptr TimeCount
	$2B $C3			#	sub	ax, bx
	$3D $0001w		#	cmp	ax, 1
	$76 $ED			#	jbe	@wait
				#@done:
	$C3			#	retn

%end